function getSetup1(fileName)
    setup = Dict()
    # name=string("../json/setupTestUni$latticeSize",".json")
    name=string("./json/$(fileName)",".json")
    open(name, "r") do f
       #global setup
        dicttxt = String(read(f))  # file information to string
        setup=JSON.parse(dicttxt)  # parse and transform data
    end
    return setup
end

function plotFinalDisplacement(name)
    setupViz=getSetup1("$(name)/0")
    maxNumFiles=setupViz["maxNumFiles"]
    setupVizLast=getSetup1("$(name)/$(Int(maxNumFiles-1))");
    nodes=setupVizLast["nodes"]
    disX=[]
    disY=[]
    disZ=[]
    for node in nodes
        append!(disX,[node["displacement"]["x"]])
        append!(disY,[node["displacement"]["y"]])
        append!(disZ,[node["displacement"]["z"]])
    end
    display(scatter(disX,label="x"))
    display(scatter(disY,label="y")) 
    display(scatter(disZ,label="z")) 
end


function plotDisplacementTroughTimeSteps(name,id)
    setupViz=getSetup1("$(name)/0")
    maxNumFiles=setupViz["maxNumFiles"]
    
    dis=[]
    for i in 0:(maxNumFiles-1)
        setupViz=getSetup1("$(name)/$(Int(i))");
        node=setupViz["nodes"][id]
        append!(dis,[node["displacement"]["y"]])

    end
    plot(dis)
end


function plotDisplacementTroughTimeSteps(name)
    setupViz=getSetup1("$(name)/0")
    maxNumFiles=setupViz["maxNumFiles"]
    
    dis=[]
    for i in 0:(maxNumFiles-1)
        setupViz=getSetup1("$(name)/$(Int(i))");
        node=setupViz["nodes"][end]
        append!(dis,[node["displacement"]["y"]])

    end
    plot(dis)
end